
function clearDisplay(whichDisplay)
{
	var obj = getObj(whichDisplay);
	if (obj == null) return;

	while(obj.lastChild)
	{
		obj.removeChild(obj.lastChild);
	}
}

function displayNumber(where, number) {
	if(isNaN(number))
		return false;
	
	var obj = getObj(where);
	var numberstring = number.toString();
	var strlen = numberstring.length;
	
	// remove old images
	while(obj.lastChild)
		obj.removeChild(obj.lastChild);
	
	// set new images
	for(var i = 0; i < strlen; i++) {
		var thisnum = numberstring.substring(i, i + 1);
		
		var img = document.createElement("img");
		if('.' != thisnum) {
			img.setAttribute("class", "number");
			img.src = "./Images/Digits/" + thisnum + ".png";
		}
		else
			img.src = "./Images/Digits/dot.png";
		obj.appendChild(img);
	}
}

function displayPercent(number) {
	if(isNaN(number))
		return false;
	
	displayNumber('uploadFileProgress', number);
	
	// add the percent-sign
	var img = document.createElement("img");
	img.setAttribute("class", "number");
	img.src = "./Images/Digits/%.png";
	getObj('uploadFileProgress').appendChild(img);
}

function displaySpeed(number) {
	if(isNaN(number))
		return false;
	
	if (number >= 1000)
	{
		if (speedGaugeShowsKBs)
		{
			// shows mb/s
			getObj('uploadSpeedUnity').src = "Images/mbsec.png";
			speedGaugeShowsKBs = false;
		}
		number /= 1024;
	} else {
		if (!speedGaugeShowsKBs)
		{
			// show kb/s
			getObj('uploadSpeedUnity').src = "Images/kbsec.png";
			speedGaugeShowsKBs = true;
		}
	}

	/*if(number >= 1000) {
		getObj('uploadSpeedUnity').src = "Images/mbsec.png";
		number /= 1024;
	}
	else {
		getObj('uploadSpeedUnity').src = "Images/kbsec.png";
	}*/
	
	var rounded = Math.floor(number * 10) / 10;
	var numberstring = rounded.toString();
	if(rounded == Math.ceil(rounded))
		rounded += ".0";
	
	displayNumber('uploadKBS', rounded);
}

// returns the object, whether you supply an id (string) or an object itself
function getObj(id) {
	var obj;
	if(typeof(id) == "string") {
		obj = getById(id) ? getById(id) : null;
	}
	else if(typeof(id) == "object") {
		obj = id;
	}
	
	return obj;
}

// returns the object with the correspondent ID
function getById(id) {
	if(document.getElementById)
		return document.getElementById(id);
	else if(document.all)
		return document.all[id];
	else
		return false;
}


function removeKeyFromHash(removeKey, array)
{
	var result = new Object();
	for (var key in array)
	{
		if (key != removeKey) result[key] = array[key];
	}
	return result;
}

function keysFromHash(hash)
{
	var keys = new Array();
	for (var key in hash)
	{
		keys.push(key);
	}
	return keys;
}

function indexOfObjectInArray(array, object)
{
	if("object" != typeof(array)) return -1;
	for (i = 0; i < array.length; i++)
	{
		if (array[i] == object) return i;
	}
	return -1;
}

function inArray(value, arr)
{
	if("object" != typeof(arr)) return false;
	
	for(var i = 0; i < arr.length; i++)
	{
		if(arr[i] == value) return true;
	}
	return false;
}

function selectVal(clicked) {
	var elem = getObj(clicked);
	while(null != elem.previousSibling) {
		if('input' == elem.previousSibling.nodeName.toLowerCase()) {
			if(! elem.previousSibling.disabled)
				elem.previousSibling.checked = ! elem.previousSibling.checked;
			return;
		}
		elem = elem.previousSibling;
	}
}

// toggles an input-elements "enabled" value
function toggleDisabledIfChecked(check, element) {
	var disable = (getObj(check) && (false == getObj(check).checked));
	var elem = getObj(element);
	
	if(elem) {
		
		// disable main element
		elem.disabled = disable;
		
		// also disable correspondend Text
		while(null != elem.nextSibling) {
			if(('span' == elem.nextSibling.nodeName.toLowerCase()) && (elem.nextSibling.className && elem.nextSibling.className.match(/clicksel/))) {
				var thisclass = elem.nextSibling.className;
				var newclass = disable ? thisclass.replace(/ disabled/g, '') + ' disabled' : thisclass.replace(/ disabled/g, '');
				
				elem.nextSibling.className = newclass;
				return;
			}
			elem = elem.nextSibling;
		}
	}
}

// selects a value in a drop-down element
function selectValue(element, value) {
	if(!element) return;
	
	for (i = 0; i < element.length; i++)
	{
		if (element.options[i].value == value)
		{
			element.selectedIndex = i;
			return;
		}
	}
}

function mergeHashes(hashOne, hashTwo)
{
	var result = new Object();
	for (var key in hashOne)
	{
		result[key] = hashOne[key];
	}
	for (var key in hashTwo)
	{
		result[key] = hashTwo[key];
	}
	return result;
}

// returns a SHALLOW copy of a hash
// not appropriate for DEEP copies!
function copyHash(hash)
{
	var result = new Object();
	for (var key in hash)
	{
		result[key] = hash[key];
	}
	return result;
}

function copyArray(array)
{
	var result = new Array();
	for (var i = 0; i < array.length; i++)
	{
		result.push(array[i]);
	}
	return result;
}

function debug(string)
{
	if (!debugMode) return;
	alert(string);
}


// JS serialization

function Serialize(obj) {
    var strSource = "";

    if (typeof(obj) == "undefined") {
        strSource = "undefined";
    }

    else if (obj == null) {
        strSource = "null";
    }

    else if (typeof(obj) == "boolean" || typeof(obj) == "number" || typeof(obj) == "function") {
        strSource = obj;
    }

    else if (typeof(obj) == "string") {
        strSource = "'" + obj.replace(/([\\'"])/g, "\\$1") + "'"; 		//" (just to avoid the texteditors problems with the single Notation Mark)
    }

    else if (typeof(obj) == "object") {
        if (obj.constructor == Boolean) {
            strSource = "new Boolean(" + obj.valueOf() + ")";
        }

        else if (obj.constructor == Number) {
            strSource = "new Number(" + obj.valueOf() + ")";
        }

        else if (obj.constructor == String) {
            strSource = "new String(" + Serialize(obj.toString()) + ")";
        }

        else if (obj.constructor == Date) {
            strSource = "new Date(" + obj.valueOf() + ")";
        }

        else if (obj.constructor == Array) {
            strSource = "[";
            for (var i=0; i<obj.length; i++)
                strSource += Serialize(obj[i]) + ",";
            if (i>0)
                strSource = strSource.substring(0, strSource.length-1);
            strSource += "]";
        }

        else if (obj.constructor == RegExp) {
            strSource = obj.toString();
        }

        else if (obj.constructor == Object) {
            var strSource = "{"
            for (var key in obj)
                strSource = strSource + "" + key + ":" + Serialize(obj[key]) + ","
            if (strSource.length > 1)
                strSource = strSource.substring(0, strSource.length-1);
            strSource += "}";
        }
    }

    else {
        throw new Error(0, "Serialize encountered unexpected object type: " + typeof(obj));
    }

    return strSource;
}


function Deserialize(strSource) {
        if (typeof strSource != "string")
                throw new Error(0, "Deserialize expects a string argument");

        var x;
        return eval("x = " + strSource);
}

